Ruby: pm_singleton_class_node Struct Reference

Ruby 3.4.7p58 (2025-10-08 revision 7a5688e2a27668e48f8d6ff4af5b2208b98a2f5e)

Data Fields
pm_singleton_class_node Struct Reference

SingletonClassNode. More...

`#include <ast.h>`

## Data Fields
pm_node_t | base
| The embedded base node.
pm_constant_id_list_t | locals
| SingletonClassNode#locals.
pm_location_t | class_keyword_loc
| SingletonClassNode#class_keyword_loc.
pm_location_t | operator_loc
| SingletonClassNode#operator_loc.
struct pm_node * | expression
| SingletonClassNode#expression.
struct pm_node * | body
| SingletonClassNode#body.
pm_location_t | end_keyword_loc
| SingletonClassNode#end_keyword_loc.
Data Fields inherited from pm_node
pm_node_type_t | type
| This represents the type of the node.
pm_node_flags_t | flags
| This represents any flags on the node.
uint32_t | node_id
| The unique identifier for this node, which is deterministic based on the source.
pm_location_t | location
| This is the location of the node in the source.

## Detailed Description

SingletonClassNode.

Represents a singleton class declaration involving the class keyword.

    class << self end
    ^^^^^^^^^^^^^^^^^

Type: ::PM_SINGLETON_CLASS_NODE

Definition at line 7322 of file ast.h.

## Field Documentation

## ◆ base

pm_node_t pm_singleton_class_node::base

The embedded base node.

Definition at line 7324 of file ast.h.

Referenced by pm_dump_json().

## ◆ body

struct pm_node* pm_singleton_class_node::body

SingletonClassNode#body.

Definition at line 7350 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

## ◆ class_keyword_loc

pm_location_t pm_singleton_class_node::class_keyword_loc

SingletonClassNode#class_keyword_loc.

Definition at line 7335 of file ast.h.

Referenced by pm_dump_json().

## ◆ end_keyword_loc

pm_location_t pm_singleton_class_node::end_keyword_loc

SingletonClassNode#end_keyword_loc.

Definition at line 7355 of file ast.h.

Referenced by pm_dump_json().

## ◆ expression

struct pm_node* pm_singleton_class_node::expression

SingletonClassNode#expression.

Definition at line 7345 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

## ◆ locals

pm_constant_id_list_t pm_singleton_class_node::locals

SingletonClassNode#locals.

Definition at line 7330 of file ast.h.

Referenced by pm_dump_json(), and pm_node_destroy().

## ◆ operator_loc

pm_location_t pm_singleton_class_node::operator_loc

SingletonClassNode#operator_loc.

Definition at line 7340 of file ast.h.

Referenced by pm_dump_json().

The documentation for this struct was generated from the following file:

- prism/ast.h